"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _PluginManager_availablePlugins;
Object.defineProperty(exports, "__esModule", { value: true });
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isImporterPlugin(plugin) {
    return plugin.import !== undefined && typeof plugin.import === 'function';
}
// eslint-disable-next-line @typescript-eslint/no-explicit-any
function isUrlGeneratorPlugin(plugin) {
    return plugin.generateUrl !== undefined && typeof plugin.generateUrl === 'function';
}
class PluginManager {
    constructor() {
        _PluginManager_availablePlugins.set(this, new Map());
    }
    registerPlugin(plugin) {
        __classPrivateFieldGet(this, _PluginManager_availablePlugins, "f").set(plugin.configKey, plugin);
    }
    getImporterPlugin(configKey) {
        const plugin = __classPrivateFieldGet(this, _PluginManager_availablePlugins, "f").get(configKey);
        if (plugin !== undefined && isImporterPlugin(plugin)) {
            return plugin;
        }
    }
    getUrlGeneratorPlugin(configKey) {
        const plugin = __classPrivateFieldGet(this, _PluginManager_availablePlugins, "f").get(configKey);
        if (plugin !== undefined && isUrlGeneratorPlugin(plugin)) {
            return plugin;
        }
    }
    getPluginsInfo() {
        return [...__classPrivateFieldGet(this, _PluginManager_availablePlugins, "f").values()].map(plugin => ({
            configKey: plugin.configKey,
            displayName: plugin.displayName,
            isImporter: isImporterPlugin(plugin),
            isUrlGenerator: isUrlGeneratorPlugin(plugin),
        }));
    }
}
exports.default = PluginManager;
_PluginManager_availablePlugins = new WeakMap();
//# sourceMappingURL=plugin-manager.js.map