"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const url_1 = require("url");
class ContrastGridPlugin {
    get configKey() {
        return 'contrast-grid';
    }
    get displayName() {
        return 'EightShapes Contrast Grid';
    }
    generateUrl(colors) {
        const url = new url_1.URL('http://contrast-grid.eightshapes.com/');
        const namedColors = colors.getNamedColors();
        // Construct a list of all colors
        const colorParam = [
            // Add "color,name" pairs from named colors
            ...Object.keys(namedColors).map(name => {
                const colorVal = namedColors[name].hex();
                return `${colorVal},${name}`;
            }),
            // Add "value" from anonymous colors
            ...colors.getAnonymousColors().map(color => color.hex())
        ].join("\n");
        // TODO: Provide some kind of way to divide input colors
        // into bg & fg categories?
        url.searchParams.append('background-colors', '');
        url.searchParams.append('foreground-colors', colorParam);
        url.searchParams.append('es-color-form__tile-size', 'compact');
        return url;
    }
}
exports.default = ContrastGridPlugin;
//# sourceMappingURL=contrast-grid.js.map