"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const url_1 = require("url");
class TintAndShadePlugin {
    get configKey() {
        return 'tintAndShade';
    }
    get displayName() {
        return 'Tint and Shade Generator';
    }
    generateUrl(colors) {
        const url = new url_1.URL('https://maketintsandshades.com/');
        const namedColors = colors.getNamedColors();
        // Construct a list of all colors
        const colorList = [
            // Add "color,name" pairs from named colors
            ...Object.keys(namedColors).map(name => {
                const colorVal = namedColors[name].hex();
                return `${colorVal.substr(1)}`;
            }),
            // Add "value" from anonymous colors
            ...colors.getAnonymousColors().map(color => color.hex().substr(1))
        ].join(",");
        url.hash = colorList;
        return url;
    }
}
exports.default = TintAndShadePlugin;
//# sourceMappingURL=tint-and-shade.js.map